package com.winhc.bigdata.spark.ng.chance.table

import com.winhc.bigdata.spark.implicits.MapHelper._
import com.winhc.bigdata.spark.ng.chance.{ChangeExtract, CompanyChanceHandle, CompanyChanceRecord, CompanyChanceUtils}

/**
 * @Date: 2021/9/29
 * @Description: 开庭公告
 */
case class company_court_open_announcement(is_inc: Boolean) extends CompanyChanceHandle {

  override def get_conditional_filter(): String ={
    "AND  new_data['case_no'] like concat('%','恢','%')"
  }

  override def filter: (String, String, Seq[String], Map[String, String], Map[String, String]) => Boolean = (update_type: String, biz_date: String, change_fields: Seq[String], old_data: Map[String, String], new_data: Map[String, String]) => {
    if (CompanyChanceUtils.default_filter(update_type, biz_date, change_fields, old_data, new_data)) {
      if (update_type.equals("insert")) true
      else
        false
    } else {
      false
    }
  }
  override def getCompanyIds(new_data: Map[String, String]): Seq[String] = {
    //Seq(new_data.getOrEmptyStr("related_company_id")) ++
      getEntity(new_data.getOrEmptyStr("defendant_info"), "litigant_id") //++
      //getEntity(new_data.getOrEmptyStr("pledgee_info"), "pledgee_id")
  }

  override def flat_map: ChangeExtract => Seq[CompanyChanceRecord] = (change_extract: ChangeExtract) => {
    getCompanyChanceRecord(change_extract, getCompanyIds(change_extract.new_data))
  }
}
