package com.winhc.bigdata.spark.ng.chance.table

import com.winhc.bigdata.spark.implicits.MapHelper._
import com.winhc.bigdata.spark.ng.chance.{ChangeExtract, CompanyChanceHandle, CompanyChanceRecord, CompanyChanceUtils}
import com.winhc.bigdata.spark.utils.BaseUtil
import org.json4s.DefaultFormats
import org.json4s.jackson.Json

/**
 * @Date: 2021/9/29
 * @Description: 裁判文书-被告-一审
 */
case class wenshu_detail_v2_bg_yishen(is_inc: Boolean) extends CompanyChanceHandle {

  override def get_conditional_filter(): String = {
    " AND  new_data['is_success'] = '胜' AND new_data['case_stage'] = '一审'  AND new_data['case_type'] = '民事案件' "
  }

  override def filter: (String, String, Seq[String], Map[String, String], Map[String, String]) => Boolean = (update_type: String, biz_date: String, change_fields: Seq[String], old_data: Map[String, String], new_data: Map[String, String]) => {
    if (CompanyChanceUtils.default_filter(update_type, biz_date, change_fields, old_data, new_data)) {
      if (update_type.equals("insert")) true
      else
        false
    } else {
      false
    }
  }

  override def get_label(new_data: Map[String, String]): String = {
    BaseUtil.getTags(new_data,"case_amt","judge_date","4")
  }

  override def getCompanyIds(new_data: Map[String, String]): Seq[String] = {
    //Seq(new_data.getOrEmptyStr("related_company_id")) ++
    getEntity(new_data.getOrEmptyStr("defendant_info"), "litigant_id") //++
    //getEntity(new_data.getOrEmptyStr("pledgee_info"), "pledgee_id")
  }

  /**
   * 原告-被告 集合
   *
   * @return
   */
  override def get_party_set(new_map: Map[String, String]): Seq[String] = {
    Seq(getEntity(new_map.getOrEmptyStr("plaintiff_info"), "name").mkString(",")
      , getEntity(new_map.getOrEmptyStr("defendant_info"), "name").mkString(","))
  }


  override def flat_map: ChangeExtract => Seq[CompanyChanceRecord] = (change_extract: ChangeExtract) => {
    getCompanyChanceRecord(change_extract, getCompanyIds(change_extract.new_data))
  }
}
