package com.winhc.bigdata.spark.ng.chance.table

import com.winhc.bigdata.spark.implicits.MapHelper._
import com.winhc.bigdata.spark.ng.chance.{ChangeExtract, CompanyChanceHandle, CompanyChanceRecord, CompanyChanceUtils}
import com.winhc.bigdata.spark.utils.BaseUtil
import org.json4s.DefaultFormats
import org.json4s.jackson.Json


/**
 * @Date: 2021/9/29
 * @Description: 裁判文书 - 原告 - 终本
 */
case class wenshu_detail_v2_yg_zhongben(is_inc: Boolean) extends CompanyChanceHandle {

  override def get_conditional_filter(): String = {
    "AND  new_data['judge_result'] like '%终结本次执行程序%' AND new_data['case_stage'] = '一审'  AND new_data['case_type'] = '民事案件'"
  }

  override def get_label(new_data: Map[String, String]): String = {
    BaseUtil.getTags(new_data,"case_amt","judge_date","6")
//    val m: Map[String, String] = Map(
//      "case_amt" -> BaseUtil.amt_div(new_data.getOrEmptyStr("case_amt"), "1",2).toString,
//      "judge_date" -> new_data.getOrEmptyStr("judge_date").split(" ")(0)
//    )
//    Json(DefaultFormats).write(m)
  }

  override def get_party_set(new_data: Map[String, String]): Seq[String] = {
    Seq(
      getEntity(new_data.getOrEmptyStr("plaintiff_info"), "name").mkString(","),
      getEntity(new_data.getOrEmptyStr("defendant_info"), "name").mkString(",")
    )
  }

  override def filter: (String, String, Seq[String], Map[String, String], Map[String, String]) => Boolean = (update_type: String, biz_date: String, change_fields: Seq[String], old_data: Map[String, String], new_data: Map[String, String]) => {
    if (CompanyChanceUtils.default_filter(update_type, biz_date, change_fields, old_data, new_data)) {
      if (update_type.equals("insert")) true
      else
        false
    } else {
      false
    }
  }

  override def getCompanyIds(new_data: Map[String, String]): Seq[String] = {
    getEntity(new_data.getOrEmptyStr("plaintiff_info"), "litigant_id")
  }

  override def flat_map: ChangeExtract => Seq[CompanyChanceRecord] = (change_extract: ChangeExtract) => {
    getCompanyChanceRecord(change_extract, getCompanyIds(change_extract.new_data))
  }
}
